(* Global variables that make the interpreter output easier to read. *)
Control.Print.printDepth  := 20;
Control.Print.printLength := 30;


(* Section 11.5 *)

(* definition of a type constructor that is like ML type int list *)
datatype intlist = INTNIL
                 | INTCONS of int * intlist;

INTNIL;              (* a value of type intlist *)
INTCONS (1, INTNIL); (* construct another value of type intlist *)
INTCONS (2, INTCONS (1, INTNIL)); (* an intlist value of "length" 2 *)

(* Here are length functions for our intlist and ML's 'a list *)
fun intlistLength INTNIL = 0
 |  intlistLength (INTCONS(_,tail)) = 1 + (intlistLength tail);

fun listLength nil = 0
 |  listLength (_::tail) = 1 + (listLength tail);

intlistLength( INTCONS (2, INTCONS (1, INTNIL)) );
listLength( 2::1::nil );



(* definition of a type constructor that is like ML type 'a list *)
datatype 'element mylist = NIL
                         | CONS of 'element * 'element mylist;

NIL;                     (* a value of type int mylist *)
CONS (1, NIL);           (* construct another value of type int mylist *)
CONS (2, CONS (1, NIL)); (* a int mylist value of "length" 2 *)

NIL;                         (* a value of type real mylist *)
CONS (1.2, NIL);             (* construct another value of type real mylist *)
CONS (2.3, CONS (1.2, NIL)); (* a real mylist value of "length" 2 *)

fun mylistLength NIL = 0
 |  mylistLength (CONS(_,tail)) = 1 + (mylistLength tail);

mylistLength( CONS (2, CONS (1, NIL)) );
mylistLength( CONS (2.3, CONS (1.2, NIL)) );


fun addup NIL = 0
 |  addup (CONS(head,tail)) = head + addup tail;

addup( CONS( 5, CONS (2, CONS (1, NIL))) );

fun myfoldr f c NIL = c
 |  myfoldr f c (CONS(a,b)) = f(a, myfoldr f c b);

 myfoldr (op +) 0 (CONS( 5, CONS (2, CONS (1, NIL))));

(* Let us make the CONS constructor for mylist into an infix operator. *)
infixr 5 CONS;

2 CONS 1 CONS NIL;
2.3 CONS 1.2 CONS NIL;
2 :: 1 :: nil;
2.3 :: 1.2 :: nil;

myfoldr (op +) 0 (5 CONS 2 CONS 1 CONS NIL);