(* Global variables that make the interpreter output easier to read. *)
Control.Print.printDepth  := 20;
Control.Print.printLength := 30;


(* from pages 174 - 176 *)

datatype 'data tree = Empty
                    | Node of 'data tree * 'data * 'data tree;

val treeEmpty = Empty;
val tree2 = Node(Empty,2,Empty);
val tree123 = Node( Node(Empty,1,Empty),
                    2,
                    Node(Empty,3,Empty) );


(* A function that increments all of the nodes in a tree. *)
fun incall Empty = Empty
 |  incall (Node(x,y,z)) = Node( incall(x), y+1, incall(z) );
(* IMPORTANT: This function does NOT modify (or mutate) its input tree.
              It constructs a new(!) tree whose nodes contain values
              incremented from the corresponding nodes of the input tree.
              Be sure you understand why. *)

incall tree123;


fun sumall Empty = 0
 |  sumall (Node(x,y,z)) = sumall(x) + y + sumall(z);

sumall tree123;
sumall (incall tree123);
sumall (incall (incall tree123));


fun listall Empty = []
 |  listall (Node(x,y,z)) = listall(x)@[y]@listall(z);

listall (incall (incall tree123));


fun preordertree Empty = []
 |  preordertree (Node(x,y,z)) = [y]@preordertree(x)@preordertree(z);

fun inordertree Empty = []
 |  inordertree (Node(x,y,z)) = inordertree(x)@[y]@inordertree(z);

fun postordertree Empty = []
 |  postordertree (Node(x,y,z)) = postordertree(x)@postordertree(z)@[y];

(* the expression tree for "a*b + c" *)
val etree = Node( Node( Node(Empty,"a",Empty),
                        "*",
                        Node(Empty, "b", Empty)),
                  "+",
                  Node(Empty, "c", Empty));

preordertree  etree;
inordertree   etree;
postordertree etree;


(* Notice how the following function is naturally efficient.
   It will not do any more tree traversing than is needed (why?). *)
fun isintree x Empty = false
 |  isintree x (Node(left,y,right)) = (x=y) orelse (isintree x left) orelse (isintree x right);

 isintree 4 tree123;

 isintree 3 tree123;