(* Global variables that make the interpreter output easier to read. *)
Control.Print.printDepth  := 20;
Control.Print.printLength := 30;


(* a binary tree datatype *)
datatype 'a btree = Empty
                  | BNode of 'a * 'a btree * 'a btree;



(* trees with arbitrary degrees *)
datatype 'a tree = ListNode of 'a * 'a tree list;



(* a binary tree data type that does NOT hold any data *)
datatype 'a etree = ELeaf
                  | ENode of etree * etree;

(* a binary tree data type with data only on the leaves *)
datatype 'a leaftree = LLeaf of 'a
                     | LNode of 'a leaftree * 'a leaftree;
(* what is the difference between the above type and next two types? *)
datatype 'a leaftree = Empty
                     | LLeaf of 'a
                     | LNode of 'a leaftree * 'a leaftree;

datatype 'a leaftree = LLeaf of 'a
                     | LNode of 'a leaftree * 'a leaftree
                     | LLNode of 'a leaftree;
                     | LRNode of 'a leaftree;


(* a binary tree data type with data only in the nodes *)
datatype 'a nodetree = NLeaf
                     | NNode of 'a * 'a nodetree * 'a nodetree

(* binary tree data types with data in both the leaves and nodes *)
datatype 'a lntree = LNLeaf of 'a
                   | LNNode of 'a * 'a lntree * 'a lntree;

datatype 'a lntree = LNLeaf of 'a
                   | LNNode of 'a * 'a lntree * 'a lntree;
                   | LNLNode of 'a lntree;
                   | LNRNode of 'a lntree;

(* binary tree data types with data, of different types, in the nodes and the leaves *)
datatype ('a,'b) abtree = ABLeaf of 'a
                        | ABNode of 'b * ('a,'b) abtree * ('a,'b) abtree;

datatype ('a,'b) abtree = ABLeaf of 'a
                        | ABNode of 'b * ('a,'b) abtree * ('a,'b) abtree;
                        | ABLNode of 'b * ('a,'b) abtree;
                        | ABRNode of 'b * ('a,'b) abtree;

(* a binary tree data type with ints on the leaves and reals in the nodes *)
datatype irtree = IRLeaf of int
                | IRNode of real * irtree * irtree;